//--- xrmb:downloadclientslist ---

//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// Stormit: DTW
#include "stdafx.h"
#include "emule.h"
#include "DownloadClientsCtrl.h"
#include "FileDetailDialog.h"
#include "otherfunctions.h"
#include "opcodes.h"
#include "ClientDetailDialog.h"
#include ".\downloadclientsctrl.h"
#include "emuleDlg.h"
#include "transferwnd.h"
#include "opcodes.h"
#include "chatwnd.h"
#include "friendlist.h"
#include "clientcredits.h"
#include "memdc.h"
#include "MenuCmds.h"
#include "FriendList.h"
#include "PartFile.h"
#include "KnownFileList.h"
#include "Version.h"
#include "UpDownClient.h"
#include "IP2Country.h" //EastShare - added by [ionix], IP to Country
#include "fakecheck.h" // [ionix] - Fakecheck


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


// CDownloadClientsCtrl

#define DCL_COLUMN_USERNAME		0
#define DCL_COLUMN_VERSION		1
#define DCL_COLUMN_FILE			2
#define DCL_COLUMN_SPEED		3
#define DCL_COLUMN_TRANSF		4
#define DCL_COLUMN_UPDL			5
#define DCL_COLUMN_RATIO		6
#define DCL_COLUMN_PROGRESS		7
#define DCL_COLUMN_FAKECHECK	8 // [ionix] - Fakecheck
#define DCL_COLUMN_COUNTRY		9 // [ionix] IP Country


#define DLC_DT_TEXT (DT_LEFT|DT_SINGLELINE|DT_VCENTER|DT_NOPREFIX|DT_END_ELLIPSIS)
#define DLC_BARUPDATE 512

IMPLEMENT_DYNAMIC(CDownloadClientsCtrl, CMuleListCtrl)
CDownloadClientsCtrl::CDownloadClientsCtrl()
	: CListCtrlItemWalk(this)
{
}

BEGIN_MESSAGE_MAP(CDownloadClientsCtrl, CMuleListCtrl)
	ON_WM_CONTEXTMENU()
	ON_WM_SYSCOLORCHANGE()
	ON_NOTIFY_REFLECT(LVN_COLUMNCLICK, OnColumnClick)
	ON_NOTIFY_REFLECT(NM_DBLCLK, OnNMDblclkDownloadClientlist)
END_MESSAGE_MAP()

void CDownloadClientsCtrl::Init()
  {
	CImageList ilDummyImageList; //dummy list for getting the proper height of listview entries
	ilDummyImageList.Create(1, theApp.GetSmallSytemIconSize().cy,theApp.m_iDfltImageListColorFlags|ILC_MASK, 1, 1); 
	SetImageList(&ilDummyImageList, LVSIL_SMALL);
	ASSERT( (GetStyle() & LVS_SHAREIMAGELISTS) == 0 );
	ilDummyImageList.Detach();

	SetExtendedStyle(LVS_EX_FULLROWSELECT);

	InsertColumn(DCL_COLUMN_USERNAME,	GetResString(IDS_QL_USERNAME),LVCFMT_LEFT, 150);
	InsertColumn(DCL_COLUMN_VERSION,    GetResString(IDS_CLIENTSOFTWARE),LVCFMT_LEFT,110); 
	InsertColumn(DCL_COLUMN_FILE,		GetResString(IDS_FILE),	LVCFMT_LEFT, 240);
	InsertColumn(DCL_COLUMN_SPEED,		GetResString(IDS_DL_SPEED),LVCFMT_LEFT, 60);
	InsertColumn(DCL_COLUMN_TRANSF,		GetResString(IDS_DL_TRANSF),LVCFMT_LEFT, 130);
	InsertColumn(DCL_COLUMN_UPDL,		GetResString(IDS_LSD_TOTAL_UP_DL),LVCFMT_LEFT, 130);
	InsertColumn(DCL_COLUMN_RATIO,		GetResString(IDS_DL_RATIO),LVCFMT_LEFT, 60);
	InsertColumn(DCL_COLUMN_PROGRESS,	GetResString(IDS_DL_PROGRESS),LVCFMT_LEFT, 170);
	InsertColumn(DCL_COLUMN_FAKECHECK,  GetResString(IDS_CHECKFAKE),LVCFMT_LEFT,220); // [ionix] - FakeCheck
	InsertColumn(DCL_COLUMN_COUNTRY,	GetResString(IDS_COUNTRY),LVCFMT_LEFT, 100);	// [ionix] IP Country
	SetAllIcons();
	Localize();

	CreateMenues(); 

	LoadSettings(CPreferences::tableDownloadClients);
	// Barry - Use preferred sort order from preferences
	int sortItem = thePrefs.GetColumnSortItem(CPreferences::tableDownloadClients);
	bool sortAscending = thePrefs.GetColumnSortAscending(CPreferences::tableDownloadClients);
	SetSortArrow(sortItem, sortAscending);

	SortItems(SortProc, sortItem + (sortAscending ? 0:100));

	if (thePrefs.GetIP2CountryNameMode() == IP2CountryName_DISABLE)
		HideColumn (8);
}

CDownloadClientsCtrl::~CDownloadClientsCtrl()
{
	if (m_clientMenu) VERIFY(m_clientMenu.DestroyMenu());
}

void CDownloadClientsCtrl::SetAllIcons() 
{
	imagelist.DeleteImageList();
	imagelist.Create(16,16,theApp.m_iDfltImageListColorFlags|ILC_MASK,0,1);
	imagelist.SetBkColor(CLR_NONE);
	imagelist.Add(CTempIconLoader(_T("ClientEDonkey"))); // 0
	imagelist.Add(CTempIconLoader(_T("ClientCompatible")));
	imagelist.Add(CTempIconLoader(_T("ClientEDonkeyPlus")));
	imagelist.Add(CTempIconLoader(_T("ClientCompatiblePlus")));
	imagelist.Add(CTempIconLoader(_T("Friend")));
	imagelist.Add(CTempIconLoader(_T("ClientMLDonkey"))); // 5
	imagelist.Add(CTempIconLoader(_T("ClientMLDonkeyPlus")));
	imagelist.Add(CTempIconLoader(_T("ClientEDonkeyHybrid")));
	imagelist.Add(CTempIconLoader(_T("ClientEDonkeyHybridPlus")));
	imagelist.Add(CTempIconLoader(_T("ClientShareaza")));
	imagelist.Add(CTempIconLoader(_T("ClientShareazaPlus"))); // 10
	imagelist.Add(CTempIconLoader(_T("ClientAMule")));
	imagelist.Add(CTempIconLoader(_T("ClientAMulePlus")));
	imagelist.Add(CTempIconLoader(_T("ClientLPhant")));
	imagelist.Add(CTempIconLoader(_T("ClientLPhantPlus")));
	imagelist.Add(CTempIconLoader(_T("IONIX"))); // [ionix] - Show iONiX icon on client detect // 15
	imagelist.Add(CTempIconLoader(_T("PREF_WEBCACHE"))); // [TPT] - WebCache // 16
	imagelist.SetOverlayImage(imagelist.Add(CTempIconLoader(_T("ClientSecureOvl"))), 1);
}

void CDownloadClientsCtrl::Localize() 
{
	imagelist.DeleteImageList();
	imagelist.Create(16,16,theApp.m_iDfltImageListColorFlags|ILC_MASK,0,1);
	imagelist.SetBkColor(CLR_NONE);
	imagelist.Add(CTempIconLoader(_T("ClientEDonkey"))); // 0
	imagelist.Add(CTempIconLoader(_T("ClientCompatible")));
	imagelist.Add(CTempIconLoader(_T("ClientEDonkeyPlus")));
	imagelist.Add(CTempIconLoader(_T("ClientCompatiblePlus")));
	imagelist.Add(CTempIconLoader(_T("Friend")));
	imagelist.Add(CTempIconLoader(_T("ClientMLDonkey"))); // 5
	imagelist.Add(CTempIconLoader(_T("ClientMLDonkeyPlus")));
	imagelist.Add(CTempIconLoader(_T("ClientEDonkeyHybrid")));
	imagelist.Add(CTempIconLoader(_T("ClientEDonkeyHybridPlus")));
	imagelist.Add(CTempIconLoader(_T("ClientShareaza")));
	imagelist.Add(CTempIconLoader(_T("ClientShareazaPlus"))); // 10
	imagelist.Add(CTempIconLoader(_T("ClientAMule")));
	imagelist.Add(CTempIconLoader(_T("ClientAMulePlus")));
	imagelist.Add(CTempIconLoader(_T("ClientLPhant")));
	imagelist.Add(CTempIconLoader(_T("ClientLPhantPlus")));
	imagelist.Add(CTempIconLoader(_T("IONIX"))); // [ionix] - Show iONiX icon on client detect // 15
	imagelist.Add(CTempIconLoader(_T("PREF_WEBCACHE"))); // [TPT] - WebCache // 16
	imagelist.SetOverlayImage(imagelist.Add(CTempIconLoader(_T("ClientSecureOvl"))), 1);

	m_overlayimages.DeleteImageList ();
	m_overlayimages.Create(16,16,theApp.m_iDfltImageListColorFlags|ILC_MASK,0,1);
	m_overlayimages.SetBkColor(CLR_NONE);

	//MORPH START - Added by [ionix], Friend Addon
	m_overlayimages.Add(CTempIconLoader(_T("ClientFriendOvl")));
	m_overlayimages.Add(CTempIconLoader(_T("ClientFriendSlotOvl")));
	//MORPH END   - Added by [ionix], Friend Addon

	CHeaderCtrl* pHeaderCtrl = GetHeaderCtrl();
	HDITEM hdi;
	hdi.mask = HDI_TEXT;
	CString strRes;

	strRes = GetResString(IDS_QL_USERNAME);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(DCL_COLUMN_USERNAME, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_CLIENTSOFTWARE);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(DCL_COLUMN_VERSION, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_FILE);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(DCL_COLUMN_FILE, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_DL_SPEED);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(DCL_COLUMN_SPEED, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_LSD_TOTAL_UP_DL);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(DCL_COLUMN_UPDL, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_DL_TRANSF);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(DCL_COLUMN_TRANSF, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_DL_RATIO);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(DCL_COLUMN_RATIO, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_DL_PROGRESS);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(DCL_COLUMN_PROGRESS, &hdi);
	strRes.ReleaseBuffer();

	// [ionix] - Fakecheck
	strRes = GetResString(IDS_CHECKFAKE);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(DCL_COLUMN_FAKECHECK, &hdi);
	strRes.ReleaseBuffer();
    // [ionix] - Fakecheck

	// [ionix] IP Country
	strRes = GetResString(IDS_COUNTRY);;
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(DCL_COLUMN_COUNTRY, &hdi);
	strRes.ReleaseBuffer();
	// [ionix] IP Country
}

void CDownloadClientsCtrl::AddClient(CUpDownClient* client)
{
	InsertItem(LVIF_TEXT|LVIF_PARAM, GetItemCount(), client->GetUserName(), 0, 0, 1, (LPARAM)client);
	RefreshClient(client);

	theApp.emuledlg->transferwnd->UpdateListCount(5);
}

void CDownloadClientsCtrl::RemoveClient(CUpDownClient* client)
 {
	LVFINDINFO find;
	find.flags = LVFI_PARAM;
	find.lParam = (LPARAM)client;
	sint32 result = FindItem(&find);
	if (result != (-1) )
		DeleteItem(result);

	theApp.emuledlg->transferwnd->UpdateListCount(5);
}

void CDownloadClientsCtrl::RefreshClient(CUpDownClient* client)
{
	// There is some type of timing issue here.. If you click on item in the queue or upload and leave
	// the focus on it when you exit the cient, it breaks on line 854 of emuleDlg.cpp
	// I added this IsRunning() check to this function and the DrawItem method and
	// this seems to keep it from crashing. This is not the fix but a patch until
	// someone points out what is going wrong.. Also, it will still assert in debug mode..
	if( !theApp.emuledlg->IsRunning() )
		return;

	LVFINDINFO find;
	find.flags = LVFI_PARAM;
	find.lParam = (LPARAM)client;
	sint16 result = FindItem(&find);
	if(result != -1)
		Update(result);
	return;
}

void CDownloadClientsCtrl::OnColumnClick( NMHDR* pNMHDR, LRESULT* pResult){
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;

	// Barry - Store sort order in preferences
	// Determine ascending based on whether already sorted on this column
	int sortItem = thePrefs.GetColumnSortItem(CPreferences::tableDownloadClients);
	bool m_oldSortAscending = thePrefs.GetColumnSortAscending(CPreferences::tableDownloadClients);
	bool sortAscending = (sortItem != pNMListView->iSubItem) ? true : !m_oldSortAscending;
	// Item is column clicked
	sortItem = pNMListView->iSubItem;
	// Save new preferences
	thePrefs.SetColumnSortItem(CPreferences::tableDownloadClients, sortItem);
	thePrefs.SetColumnSortAscending(CPreferences::tableDownloadClients, sortAscending);
	// Sort table
	SetSortArrow(sortItem, sortAscending);
	SortItems(SortProc, sortItem + (sortAscending ? 0:100));

	*pResult = 0;
}

void CDownloadClientsCtrl::CreateMenues() {
	if (m_clientMenu) VERIFY(m_clientMenu.DestroyMenu());
	m_clientMenu.CreatePopupMenu();
	m_clientMenu.AddMenuTitle(GetResString(IDS_CLIENTS), true);
	m_clientMenu.AppendMenu(MF_STRING,MP_DETAIL, GetResString(IDS_SHOWDETAILS), _T("CLIENTDETAILS"));
	m_clientMenu.AppendMenu(MF_STRING,MP_ADDFRIEND, GetResString(IDS_ADDFRIEND), _T("ADDFRIEND"));
	m_clientMenu.AppendMenu(MF_STRING,MP_MESSAGE, GetResString(IDS_SEND_MSG), _T("SENDMESSAGE"));
	m_clientMenu.AppendMenu(MF_STRING,MP_SHOWLIST, GetResString(IDS_VIEWFILES), _T("VIEWFILES"));
}

BOOL CDownloadClientsCtrl::OnCommand(WPARAM wParam,LPARAM lParam ){
	if (GetSelectionMark() != (-1))
	{
		CUpDownClient* client = (CUpDownClient*)GetItemData(GetSelectionMark());
		switch (wParam)
		{
		case MP_SHOWLIST:
			client->RequestSharedFileList();
			break;

		case MP_MESSAGE:
			theApp.emuledlg->chatwnd->StartSession(client);
			break;

		case MP_ADDFRIEND:
			theApp.friendlist->AddFriend(client);
			break;

		case MP_REMOVEFRIEND:{ //LSD
			if (client && client->IsFriend()){					
				theApp.friendlist->RemoveFriend(client->m_Friend);
				theApp.emuledlg->transferwnd->downloadlistctrl.UpdateItem(client);
			}
			break;
							 }

		case MP_FRIENDSLOT:
			{
				if (client){
					bool IsAlready;
					IsAlready = client->GetFriendSlot();
					//theApp.friendlist->RemoveAllFriendSlots();
					if( IsAlready ) {
						client->SetFriendSlot(false);
					}else 
					{
						client->SetFriendSlot(true);
					}
					theApp.friendlist->ShowFriends();
					theApp.emuledlg->transferwnd->downloadlistctrl.UpdateItem(client);
				}
				break;
			}
		case MP_DETAIL:
			CClientDetailDialog dialog(client);
			dialog.DoModal();
			break;
		}
	}
	return true;
}

int CDownloadClientsCtrl::SortProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort){
	CUpDownClient* client1 = (CUpDownClient*)lParam1;
	CUpDownClient* client2 = (CUpDownClient*)lParam2;
	switch(lParamSort){
	case (DCL_COLUMN_USERNAME + 100): 
		if(client2->GetUserName() == client1->GetUserName())
			return 0;
		else if(!client2->GetUserName())
			return 1;
		else if(!client1->GetUserName())
			return -1;
		return _tcsicmp(client2->GetUserName(),client1->GetUserName());
	case DCL_COLUMN_USERNAME: 
		if(client1->GetUserName() == client2->GetUserName())
			return 0;
		else if(!client1->GetUserName())
			return 1;
		else if(!client2->GetUserName())
			return -1;
		return _tcsicmp(client1->GetUserName(),client2->GetUserName());
			// Pawcio: Mod Version
	case (DCL_COLUMN_VERSION + 100):
			return theApp.emuledlg->transferwnd->Mod_Version_Sort_by_String	(client2,client1); //Sort By String
	case DCL_COLUMN_VERSION:
			return theApp.emuledlg->transferwnd->Mod_Version_Sort_by_String	(client1,client2); //Sort By String
			// Pawcio: Mod Version
	case (DCL_COLUMN_FILE + 100): 
		if (!client2->GetRequestFile())
			return -1;
		if (!client1->GetRequestFile())
			return 1;
		return client2->GetRequestFile()->GetFileName().CompareNoCase(client1->GetRequestFile()->GetFileName());
	case DCL_COLUMN_FILE:
		if (!client1->GetRequestFile())
			return -1;
		if (!client2->GetRequestFile())
			return 1;
		return client1->GetRequestFile()->GetFileName().CompareNoCase(client2->GetRequestFile()->GetFileName());
	case (DCL_COLUMN_SPEED + 100):
		return CompareUnsigned(client2->GetDownloadDatarate(), client1->GetDownloadDatarate());
	case DCL_COLUMN_SPEED:
		return CompareUnsigned(client1->GetDownloadDatarate(), client2->GetDownloadDatarate());
	case (DCL_COLUMN_TRANSF + 100):
		return CompareUnsigned(client2->GetTransferredDown(), client1->GetTransferredDown());
	case DCL_COLUMN_TRANSF:
		return CompareUnsigned(client1->GetTransferredDown(), client2->GetTransferredDown());
	case (DCL_COLUMN_UPDL + 100):
		if (client2->Credits() && client1->Credits())
			return client2->Credits()->GetDownloadedTotal() - client1->Credits()->GetDownloadedTotal();
		else if (!client2->Credits())
			return -1;
		else if (!client1->Credits())
			return 1;
		else
			return 0;
	case DCL_COLUMN_UPDL:
		if (client2->Credits() && client1->Credits())
			return client2->Credits()->GetUploadedTotal() - client1->Credits()->GetUploadedTotal();
		else if (!client1->Credits())
			return -1;
		else if (!client2->Credits())
			return 1;
		else
			return 0;
	case (DCL_COLUMN_RATIO + 100):
		{
			if (client2->Credits() && client1->Credits()){
				float r1=client2->credits->GetScoreRatio(client2->GetIP());
				float r2=client1->credits->GetScoreRatio(client1->GetIP());
				return r1==r2? 0 : r1<r2? -1 : 1;
			}
			else if (!client2->Credits())
				return -1;
			else if (!client1->Credits())
				return 1;
			else
				return 0;
		}
	case DCL_COLUMN_RATIO:
		{
			if (client2->Credits() && client1->Credits()){
				float r1=client1->credits->GetScoreRatio(client1->GetIP());
				float r2=client2->credits->GetScoreRatio(client2->GetIP());
				return r1==r2? 0 : r1<r2? -1 : 1;
			}
			else if (!client1->Credits())
				return -1;
			else if (!client2->Credits())
				return 1;
			else
				return 0;
		}
	// [ionix] - Fakecheck
		case DCL_COLUMN_FAKECHECK:
				return CompareOptLocaleStringNoCase(client1->GetFakeComment(), client2->GetFakeComment());
		case (DCL_COLUMN_FAKECHECK + 100):
				return CompareOptLocaleStringNoCase(client1->GetFakeComment(), client2->GetFakeComment());
	// [ionix] - Fakecheck end
	// [ionix] IP Country
	case DCL_COLUMN_COUNTRY:
			if(client1->GetCountryName(true) && client2->GetCountryName(true))
				return CompareLocaleStringNoCase(client1->GetCountryName(true), client2->GetCountryName(true));
			else if(client1->GetCountryName(true))
				return 1;
			else
				return -1;
	case (DCL_COLUMN_COUNTRY + 100):
			if(client1->GetCountryName(true) && client2->GetCountryName(true))
				return CompareLocaleStringNoCase(client2->GetCountryName(true), client1->GetCountryName(true));
			else if(client2->GetCountryName(true))
				return 1;
			else
				return -1;
	// [ionix] IP Country

	default:
		return 0;
	}
}

void CDownloadClientsCtrl::OnContextMenu(CWnd* pWnd, CPoint point)
{
	int iSel = GetNextItem(-1, LVIS_SELECTED | LVIS_FOCUSED);
	const CUpDownClient* client = (iSel != -1) ? (CUpDownClient*)GetItemData(iSel) : NULL;

	CTitleMenu ClientMenu;
	ClientMenu.CreatePopupMenu();
	ClientMenu.AddMenuTitle(GetResString(IDS_CLIENTS),true);
	ClientMenu.AppendMenu(MF_STRING | (client ? MF_ENABLED : MF_GRAYED), MP_DETAIL, GetResString(IDS_SHOWDETAILS), _T("CLIENTDETAILS"));
	ClientMenu.SetDefaultItem(MP_DETAIL);
	ClientMenu.AppendMenu(MF_STRING | ((client && client->IsEd2kClient() && !client->IsFriend()) ? MF_ENABLED : MF_GRAYED), MP_ADDFRIEND, GetResString(IDS_ADDFRIEND), _T("ADDFRIEND"));
	//MORPH START - Added by [ionix], Friend Addon
	ClientMenu.AppendMenu(MF_STRING | ((client && client->IsEd2kClient() && client->IsFriend()) ? MF_ENABLED : MF_GRAYED), MP_REMOVEFRIEND, GetResString(IDS_REMOVEFRIEND), _T("DELETEFRIEND"));
	ClientMenu.AppendMenu(MF_STRING | ((client && client->IsEd2kClient() && client->IsFriend()) ? MF_ENABLED  | ((!client->HasLowID() && client->GetFriendSlot())?MF_CHECKED : MF_UNCHECKED) : MF_GRAYED), MP_FRIENDSLOT, GetResString(IDS_FRIENDSLOT), _T("FRIENDSLOT"));
	//MORPH END - Added by [ionix], Friend Addon
	ClientMenu.AppendMenu(MF_STRING | ((client && client->IsEd2kClient()) ? MF_ENABLED : MF_GRAYED), MP_MESSAGE, GetResString(IDS_SEND_MSG), _T("SENDMESSAGE"));
	ClientMenu.AppendMenu(MF_STRING | ((client && client->IsEd2kClient() && client->GetViewSharedFilesSupport()) ? MF_ENABLED : MF_GRAYED), MP_SHOWLIST, GetResString(IDS_VIEWFILES), _T("VIEWFILES"));
	GetPopupMenuPos(*this, point);
	ClientMenu.TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON, point.x, point.y, this);
}

void CDownloadClientsCtrl::ShowSelectedUserDetails() {
	POINT point;
	::GetCursorPos(&point);
	CPoint p = point; 
    ScreenToClient(&p); 
    int it = HitTest(p); 
	if (it == -1)
		return;

	SetItemState(-1, 0, LVIS_SELECTED);
	SetItemState(it, LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED);
	SetSelectionMark(it);   // display selection mark correctly! 

	CUpDownClient* client = (CUpDownClient*)GetItemData(GetSelectionMark());
		if (client){
		CClientDetailDialog dialog(client, this);
		dialog.DoModal();
	}
}

void CDownloadClientsCtrl::OnNMDblclkDownloadClientlist(NMHDR *pNMHDR, LRESULT *pResult) {
	int iSel = GetNextItem(-1, LVIS_SELECTED | LVIS_FOCUSED);
	if (iSel != -1){
		CUpDownClient* client = (CUpDownClient*)GetItemData(iSel);
		if (client){
			CClientDetailDialog dialog(client,this);
			dialog.DoModal();
		}
	}
	*pResult = 0;
}

void CDownloadClientsCtrl::OnSysColorChange()
{
	CMuleListCtrl::OnSysColorChange();
	SetAllIcons();
}
void CDownloadClientsCtrl::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct)
{

	if( !theApp.emuledlg->IsRunning() )
		return;
	if (!lpDrawItemStruct->itemData)
		return;

	CDC* odc = CDC::FromHandle(lpDrawItemStruct->hDC);
	BOOL bCtrlFocused = ((GetFocus() == this ) || (GetStyle() & LVS_SHOWSELALWAYS));
	if( odc && (lpDrawItemStruct->itemAction | ODA_SELECT) && (lpDrawItemStruct->itemState & ODS_SELECTED )){
		if(bCtrlFocused)
			odc->SetBkColor(m_crHighlight);
		else
			odc->SetBkColor(m_crNoHighlight);
	}
	else
		odc->SetBkColor(GetBkColor());

	CUpDownClient* client = (CUpDownClient*)lpDrawItemStruct->itemData;
	CtrlItem_Struct* content = (CtrlItem_Struct*)lpDrawItemStruct->itemData;

	CMemDC dc(CDC::FromHandle(lpDrawItemStruct->hDC),&CRect(lpDrawItemStruct->rcItem));
	CFont *pOldFont = dc.SelectObject(GetFont());
	RECT cur_rec;
	MEMCOPY(&cur_rec,&lpDrawItemStruct->rcItem,sizeof(RECT));
	COLORREF crOldTextColor = dc.SetTextColor(m_crWindowText);

	CString Sbuffer;	
	CKnownFile* file = client->GetRequestFile();
	CHeaderCtrl *pHeaderCtrl = GetHeaderCtrl();
	int iCount = pHeaderCtrl->GetItemCount();
	cur_rec.right = cur_rec.left - 8;
	cur_rec.left += 4;

	for(int iCurrent = 0; iCurrent < iCount; iCurrent++){
		int iColumn = pHeaderCtrl->OrderToIndex(iCurrent);
		if( !IsColumnHidden(iColumn) ){
			cur_rec.right += GetColumnWidth(iColumn);
			switch(iColumn)
			{
				case DCL_COLUMN_USERNAME:
					{
						uint8 image;
						if (client->IsFriend())
							image = 4;
						// [ionix] - Show iONiX icon on client detect
						else if (client->GetiONiXClient())
							image = 15;
						// [ionix] - Show iONiX icon on client detect
						else if (client->GetClientSoft() == SO_EDONKEYHYBRID){
							if (client->credits && client->credits->GetScoreRatio(client->GetIP()) > 1) 
								image = 8;
							else
								image = 7;
						}
						else if (client->GetClientSoft() == SO_MLDONKEY){
							if (client->credits && client->credits->GetScoreRatio(client->GetIP()) > 1) 
								image = 6;
							else
								image = 5;
						}
						else if (client->GetClientSoft() == SO_SHAREAZA){
							if(client->credits && client->credits->GetScoreRatio(client->GetIP()) > 1)
								image = 10;
							else
								image = 9;
						}
						else if (client->GetClientSoft() == SO_AMULE){
							if(client->credits && client->credits->GetScoreRatio(client->GetIP()) > 1)
								image = 12;
							else
								image = 11;
						}
						else if (client->GetClientSoft() == SO_LPHANT){
							if(client->credits && client->credits->GetScoreRatio(client->GetIP()) > 1)
								image = 14;
							else
								image = 13;
						}
						else if (client->ExtProtocolAvailable()){
							if(client->credits && client->credits->GetScoreRatio(client->GetIP()) > 1)
								image = 3;
							else
								image = 1;
						}
						else{
							if (client->credits && client->credits->GetScoreRatio(client->GetIP()) > 1)
								image = 2;
							else
								image = 0;
						}
						// [TPT] - WebCache
						bool isWebCache = (client->SupportsWebCache() || client->IsProxy())?true:false;
						uint8 morespace = 0; //WiZaRd
						if (isWebCache)
						{
							POINT point= {cur_rec.left-4,cur_rec.top+2};
							imagelist.Draw(dc, 16, point, ILD_NORMAL);
							cur_rec.left+=9;
							morespace += 9;
						}
						// [TPT] - WebCache
						POINT point = {cur_rec.left, cur_rec.top+1};
						imagelist.Draw(dc,image, point, ILD_NORMAL | ((client->Credits() && client->Credits()->GetCurrentIdentState(client->GetIP()) == IS_IDENTIFIED) ? INDEXTOOVERLAYMASK(1) : 0));
						cur_rec.left +=20;	

						// [ionix] - WiZaRd - IP Country							
						if(theApp.ip2country->ShowCountryFlag()) 
						{ 
							POINT point = {cur_rec.left,cur_rec.top+1}; 
							cur_rec.left+=20; 
							morespace += 20;
							theApp.ip2country->GetFlagImageList()->DrawIndirect(dc, client->GetCountryFlagIndex(), point, CSize(18,16), CPoint(0,0), ILD_NORMAL); 
						}

						// [ionix] - WiZaRd - IP Country	
						Sbuffer = client->GetUserName();
						dc->DrawText(Sbuffer,Sbuffer.GetLength(),&cur_rec,DLC_DT_TEXT);
						cur_rec.left -= (20+morespace);		
					break;
				}
				case DCL_COLUMN_FILE:
					if(file)
						Sbuffer = file->GetFileName();
					else
						Sbuffer = _T("?");
					break;
				case DCL_COLUMN_SPEED:
					Sbuffer.Format(_T("%s"), CastItoXBytes(client->GetDownloadDatarate(), false, true));
					break;
				case DCL_COLUMN_VERSION:{
					Sbuffer = client->GetClientSoftVer();
					if (Sbuffer.IsEmpty())
						Sbuffer = GetResString(IDS_UNKNOWN);
						break;
					}
				case DCL_COLUMN_TRANSF:
					Sbuffer.Format( _T("%s"), CastItoXBytes((float)client->GetTransferredDown()));
					break;
				case DCL_COLUMN_UPDL:
					if (client->Credits()){
						Sbuffer.Format( _T("%s/%s"),
							CastItoXBytes((float)client->Credits()->GetUploadedTotal()),
							CastItoXBytes((float)client->Credits()->GetDownloadedTotal()));
					}
					else{
						Sbuffer.Format( _T("%s/%s"),"?","?");
					}
					break;
				case DCL_COLUMN_RATIO:
					if (client->Credits()){
						Sbuffer.Format(_T("%.1f"), client->credits->GetScoreRatio(client->GetIP()));
					}
					else{
						Sbuffer.Format( _T("%s"),_T("?"));
					}
					break;
				case DCL_COLUMN_PROGRESS:
				{
					cur_rec.bottom--;
					cur_rec.top++;
					if (client->GetRequestFile())
					client->DrawStatusBar(dc, &cur_rec,false, thePrefs.UseFlatBar()); 
					cur_rec.bottom++;
					cur_rec.top--;
				}
				break;
			// [ionix] - WiZaRd - Fakecheck
				case DCL_COLUMN_FAKECHECK:{ 
                    Sbuffer = _T("No fake"); 
                    CKnownFile* file = client->GetRequestFile(); 
                    if(file) 
                    { 
						CString tmp = theApp.FakeCheck->IsFake((uchar*)file->GetFileHash(), file->GetFileSize()) ? _tcsdup(theApp.FakeCheck->GetLastHit()) : NULL;; 

						if(!tmp.IsEmpty()) 
                             Sbuffer = tmp; 
                    }                          
                    dc->DrawText(Sbuffer, Sbuffer.GetLength() ,&cur_rec, DLC_DT_TEXT); 
					break;
				}
			// [ionix] - WiZaRd - Fakecheck end
			// [ionix] - IP Country
            case DCL_COLUMN_COUNTRY:      
				if(theApp.ip2country->ShowCountryFlag()) 
                { 
					POINT point= {cur_rec.left,cur_rec.top+1}; 
                    theApp.ip2country->GetFlagImageList()->DrawIndirect(dc, client->GetCountryFlagIndex(), point, CSize(18,16), CPoint(0,0), ILD_NORMAL); 
                    cur_rec.left+=20; 
				} 
                if (client->GetCountryName().IsEmpty()) 
					Sbuffer.Format(_T("")); 
                    else 
                    Sbuffer = client->GetCountryName();                                                   
                    dc->DrawText(Sbuffer,Sbuffer.GetLength(),&cur_rec,DLC_DT_TEXT); 
				if(theApp.ip2country->ShowCountryFlag()) 
					cur_rec.left-=20; 
            // [ionix] - IP Country		
				break;
	}
			if( iColumn != DCL_COLUMN_USERNAME && iColumn != DCL_COLUMN_PROGRESS && iColumn != DCL_COLUMN_COUNTRY) // [ionix] - IP Country
				dc->DrawText(Sbuffer,Sbuffer.GetLength(),&cur_rec,DLC_DT_TEXT);
			cur_rec.left += GetColumnWidth(iColumn);
		}
	}
	
	//draw rectangle around selected item(s)
	if ((lpDrawItemStruct->itemAction | ODA_SELECT) && (lpDrawItemStruct->itemState & ODS_SELECTED))
	{
		RECT outline_rec;
		MEMCOPY(&outline_rec,&lpDrawItemStruct->rcItem,sizeof(RECT));

		outline_rec.top--;
		outline_rec.bottom++;
		dc->FrameRect(&outline_rec, &CBrush(GetBkColor()));
		outline_rec.top++;
		outline_rec.bottom--;
		outline_rec.left++;
		outline_rec.right--;

		if(bCtrlFocused)
			dc->FrameRect(&outline_rec, &CBrush(m_crFocusLine));
		else
			dc->FrameRect(&outline_rec, &CBrush(m_crNoFocusLine));
	}

	dc.SelectObject(pOldFont);
	dc.SetTextColor(crOldTextColor);
}

