//this file is part of eMule
//Copyright (C)2002 Merkur ( devs@emule-project.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#include "stdafx.h"
#include <math.h>
#include "emule.h"
#include "PPgConnection.h"
#include "PPgWebcachesettings.h" // WebCache: jp
#include "PreferencesDlg.h" // WebCache: jp
#include "emuleDlg.h" // WebCache: jp
#include "wizard.h"
#include "Scheduler.h"
#include "OtherFunctions.h"
#include "emuledlg.h"
#include "Preferences.h"
#include "Opcodes.h"
#include "StatisticsDlg.h"
#include "Kademlia/Kademlia/Kademlia.h"
#include "HelpIDs.h"
#include "Statistics.h"
#include "Firewallopener.h"
#include "ListenSocket.h"
#include "ClientUDPSocket.h"
#include ".\ppgconnection.h"

#include "HyperTextCtrl.h" // MMS

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#endif


IMPLEMENT_DYNAMIC(CPPgConnection, CPropertyPage)
CPPgConnection::CPPgConnection()
	: CPropertyPage(CPPgConnection::IDD)
{
	guardian=false;
	 MSSCommentbox=0; //Pawcio: MSS (from LSD)
}

CPPgConnection::~CPPgConnection()
{
	if (MSSCommentbox){//Pawcio: MSS (from LSD)
		delete MSSCommentbox;
		MSSCommentbox=NULL;
	}
}

void CPPgConnection::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);

	// [ionix] [MoNKi: -Random Ports-]
	CString text;

	DDX_Control(pDX, IDC_MINPORT, m_minRndPort);
	m_minRndPort.GetWindowText(text);
	DDV_MinMaxInt(pDX,_ttoi(text),1,0xFFFF);

	DDX_Control(pDX, IDC_MAXPORT, m_maxRndPort);
	m_maxRndPort.GetWindowText(text);
	DDV_MinMaxInt(pDX,_ttoi(text),1,0xFFFF);

	DDX_Control(pDX, IDC_SPIN_MIN, m_minRndPortSpin);
	DDX_Control(pDX, IDC_SPIN_MAX, m_maxRndPortSpin);
	// [ionix] [MoNKi: -Random Ports-]

	//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
	DDX_Control(pDX, IDC_MAXUP, m_maxUpload);
	DDX_Control(pDX, IDC_MAXDOWN, m_maxDownload);
	// Maella end
}

BEGIN_MESSAGE_MAP(CPPgConnection, CPropertyPage)
	ON_EN_CHANGE(IDC_MSS	, OnSettingsChange)
	ON_BN_CLICKED(IDC_STARTTEST, OnStartPortTest)
	ON_EN_CHANGE(IDC_DOWNLOAD_CAP, OnSettingsChange)
	ON_BN_CLICKED(IDC_UDPDISABLE, OnEnChangeUDPDisable)
	ON_EN_CHANGE(IDC_UDPPORT, OnEnChangeUDP)
	ON_EN_CHANGE(IDC_UPLOAD_CAP, OnSettingsChange)
	ON_EN_CHANGE(IDC_MAXDOWN, OnSettingsChange)
	ON_EN_CHANGE(IDC_MAXUP, OnSettingsChange)
	ON_EN_CHANGE(IDC_PORT, OnEnChangeTCP)
	ON_EN_CHANGE(IDC_MAXCON, OnSettingsChange)
	ON_EN_CHANGE(IDC_MAXSOURCEPERFILE, OnSettingsChange)
	ON_BN_CLICKED(IDC_AUTOCONNECT, OnSettingsChange)
	ON_BN_CLICKED(IDC_RECONN, OnSettingsChange)
	ON_BN_CLICKED(IDC_WIZARD, OnBnClickedWizard)
	ON_BN_CLICKED(IDC_NETWORK_ED2K, OnSettingsChange)
	ON_BN_CLICKED(IDC_SHOWOVERHEAD, OnSettingsChange)
	ON_BN_CLICKED(IDC_ULIMIT_LBL, OnLimiterChange)
	ON_BN_CLICKED(IDC_DLIMIT_LBL, OnLimiterChange)
	ON_BN_CLICKED(IDC_NETWORK_KADEMLIA, OnSettingsChange)
	ON_WM_HELPINFO()
	ON_BN_CLICKED(IDC_OPENPORTS, OnBnClickedOpenports)
	// [ionix] [MoNKi: -Random Ports-]
	ON_BN_CLICKED(IDC_RANDOMPORTS, OnRandomPortsChange)
	//MORPH END   - Added by [ionix], [MoNKi: -Random Ports-]
	// [ionix] [MoNKi: -Random Ports-]
END_MESSAGE_MAP()


// CPPgConnection message handlers
void CPPgConnection::OnEnChangeTCP(){
	OnEnChangePorts(true);
}

void CPPgConnection::OnEnChangeUDP(){
	OnEnChangePorts(false);
}

void CPPgConnection::OnEnChangePorts(uint8 istcpport){


	// ports unchanged?
	CString buffer;
	GetDlgItem(IDC_PORT)->GetWindowText(buffer);
	uint16 tcp= _tstoi(buffer);
	GetDlgItem(IDC_UDPPORT)->GetWindowText(buffer);
	uint16 udp= _tstoi(buffer);

	GetDlgItem(IDC_STARTTEST)->EnableWindow( 
		tcp==theApp.listensocket->GetConnectedPort() && 
		udp==theApp.clientudp->GetConnectedPort() 
	);


	if (istcpport==0)
		OnEnChangeUDPDisable();
	else if (istcpport==1)
		OnSettingsChange();
}

void CPPgConnection::OnEnChangeUDPDisable(){
		if (guardian) return;

		uint16 tempVal=0;
		CString strBuffer;
		TCHAR buffer[510];
		
		guardian=true;
		SetModified();

	// [ionix] [MoNKi: -Random Ports-]
		/*
		GetDlgItem(IDC_UDPPORT)->EnableWindow(!IsDlgButtonChecked(IDC_UDPDISABLE));
		*/
		GetDlgItem(IDC_UDPPORT)->EnableWindow(!IsDlgButtonChecked(IDC_UDPDISABLE) && !IsDlgButtonChecked(IDC_RANDOMPORTS));
	// [ionix] [MoNKi: -Random Ports-]

		if(GetDlgItem(IDC_UDPPORT)->GetWindowTextLength())
		{
			GetDlgItem(IDC_UDPPORT)->GetWindowText(buffer,20);
			tempVal= _tstoi(buffer);
		}

		
		if (IsDlgButtonChecked(IDC_UDPDISABLE) || (!IsDlgButtonChecked(IDC_UDPDISABLE) && tempVal==0)){
			tempVal= (_tstoi(buffer)) ? _tstoi(buffer)+10 : thePrefs.port+10;
			if ( IsDlgButtonChecked(IDC_UDPDISABLE))
				tempVal=0;
			strBuffer.Format(_T("%d"), tempVal);
			GetDlgItem(IDC_UDPPORT)->SetWindowText(strBuffer);
		}

		guardian=false;
}

BOOL CPPgConnection::OnInitDialog()
{
	CPropertyPage::OnInitDialog();
	InitWindowStyles(this);

	// [ionix] [MoNKi: -Random Ports-]
	m_minRndPortSpin.SetBuddy(&m_minRndPort);
	m_minRndPortSpin.SetRange32(1,0xffff);
	m_maxRndPortSpin.SetBuddy(&m_maxRndPort);
	m_maxRndPortSpin.SetRange32(1,0xffff);
	// [ionix] [MoNKi: -Random Ports-]

	LoadSettings();
	Localize();
	//MSS msg box //Pawcio: MSS (from LSD)
	CRect rect;
	GetDlgItem(IDC_MSSLINK)->GetWindowRect(rect);
	::MapWindowPoints(NULL, m_hWnd, (LPPOINT)&rect, 2);
	ASSERT (m_hWnd != NULL);
	// Mighty Knife: MSSCommentbox is now created dynamically instead of statically !
	// Reason: Bug in CHyperTextControl: CreateEx cannot be used more than once without
	// throwing a debug assertion !
	if (MSSCommentbox){//Pawcio Fix
		delete MSSCommentbox;
		MSSCommentbox = NULL;
	}
	MSSCommentbox = new CHyperTextCtrl;
	MSSCommentbox->CreateEx(WS_EX_DLGMODALFRAME | WS_EX_CLIENTEDGE,NULL,_T("MsgWnd"),WS_VISIBLE | WS_CHILD | HTC_WORDWRAP | HTC_UNDERLINE_HOVER,rect.left,rect.top,rect.Width(),rect.Height(),m_hWnd,0);
	MSSCommentbox->Clear();
	//MSSCommentbox->AppendText(GetResString(IDC_MSSLINK)+CString(" \n "),false);
	MSSCommentbox->AppendHyperLink(CString("dslreports.com"),0,CString("http://www.dslreports.com/tweaks"),0,false);
	MSSCommentbox->AppendText(CString(" ")+GetResString(IDS_OR)+CString(" "),false);
	MSSCommentbox->AppendHyperLink(CString("speedguide.net"),0,CString("http://www.speedguide.net/analyzer.php"),0,false);
	// [end] Mighty Knife

	OnEnChangePorts(2);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CPPgConnection::LoadSettings(void)
{
	if(m_hWnd)
	{
		//Pawcio: MSS (from LSD)
		CString buffer;
		buffer.Format(_T("%i"), thePrefs.MSS); // added by [ionix] - MSS
		GetDlgItem(IDC_MSS)->SetWindowText(buffer); // added by [ionix] - MSS
		//Pawcio: MSS (from LSD)
		CheckDlgButton( IDC_DLIMIT_LBL, (thePrefs.maxdownload!=UNLIMITED) );
		CheckDlgButton( IDC_ULIMIT_LBL, (thePrefs.maxupload!=UNLIMITED) );

		//Pawcio: BC - limits shown in Bandwidth Control tab
		CString strBuffer;
		
		strBuffer.Format(_T("%d"), thePrefs.udpport);
		GetDlgItem(IDC_UDPPORT)->SetWindowText(strBuffer);
		CheckDlgButton(IDC_UDPDISABLE,(thePrefs.udpport==0));

	// [ionix] [MoNKi: -Random Ports-]
		/*		
		GetDlgItem(IDC_UDPPORT)->EnableWindow(thePrefs.udpport>0);
		*/
	// [ionix] [MoNKi: -Random Ports-]
	
		strBuffer.Format(_T("%d"), thePrefs.maxGraphDownloadRate);
		GetDlgItem(IDC_DOWNLOAD_CAP)->SetWindowText(strBuffer);

		strBuffer.Format(_T("%d"), thePrefs.maxGraphUploadRate);
		GetDlgItem(IDC_UPLOAD_CAP)->SetWindowText(strBuffer);

		//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
		strBuffer.Format(_T("%.1f"), thePrefs.GetMaxDownload());
		GetDlgItem(IDC_MAXDOWN)->SetWindowText(strBuffer);
		strBuffer.Format(_T("%.1f"), thePrefs.GetMaxUpload());
		GetDlgItem(IDC_MAXUP)->SetWindowText(strBuffer);
		//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-

		strBuffer.Format(_T("%d"), thePrefs.port);
		GetDlgItem(IDC_PORT)->SetWindowText(strBuffer);

		strBuffer.Format(_T("%d"), thePrefs.maxconnections);
		GetDlgItem(IDC_MAXCON)->SetWindowText(strBuffer);

		if(thePrefs.maxsourceperfile == 0xFFFF)
			GetDlgItem(IDC_MAXSOURCEPERFILE)->SetWindowText(_T("0"));
		else
		{
			strBuffer.Format(_T("%d"), thePrefs.maxsourceperfile);
			GetDlgItem(IDC_MAXSOURCEPERFILE)->SetWindowText(strBuffer);
		}

		if (thePrefs.reconnect)
			CheckDlgButton(IDC_RECONN,1);
		else
			CheckDlgButton(IDC_RECONN,0);
		
		if (thePrefs.m_bshowoverhead)
			CheckDlgButton(IDC_SHOWOVERHEAD,1);
		else
			CheckDlgButton(IDC_SHOWOVERHEAD,0);

		if (thePrefs.autoconnect)
			CheckDlgButton(IDC_AUTOCONNECT,1);
		else
			CheckDlgButton(IDC_AUTOCONNECT,0);

		if (thePrefs.networkkademlia)
			CheckDlgButton(IDC_NETWORK_KADEMLIA,1);
		else
			CheckDlgButton(IDC_NETWORK_KADEMLIA,0);

		if (thePrefs.networked2k)
			CheckDlgButton(IDC_NETWORK_ED2K,1);
		else
			CheckDlgButton(IDC_NETWORK_ED2K,0);

		if (theApp.m_pFirewallOpener->DoesFWConnectionExist())
			GetDlgItem(IDC_OPENPORTS)->EnableWindow(true);
		else
			GetDlgItem(IDC_OPENPORTS)->EnableWindow(false);

	// [ionix] [MoNKi: -Random Ports-]
		CString rndText;

		CheckDlgButton(IDC_RANDOMPORTS,thePrefs.GetUseRandomPorts());
		rndText.Format(_T("%u"), thePrefs.GetMinRandomPort());
		m_minRndPort.SetWindowText(rndText);
		rndText.Format(_T("%u"), thePrefs.GetMaxRandomPort());
		m_maxRndPort.SetWindowText(rndText);

		GetDlgItem(IDC_PORT)->EnableWindow(!thePrefs.GetUseRandomPorts());
		GetDlgItem(IDC_UDPPORT)->EnableWindow(!thePrefs.GetUseRandomPorts() && thePrefs.udpport>0);
		
		m_minRndPort.EnableWindow(thePrefs.GetUseRandomPorts());
		m_maxRndPort.EnableWindow(thePrefs.GetUseRandomPorts());
		m_minRndPortSpin.EnableWindow(thePrefs.GetUseRandomPorts());
		m_maxRndPortSpin.EnableWindow(thePrefs.GetUseRandomPorts());
	// [ionix] [MoNKi: -Random Ports-]

		OnLimiterChange();
	}
}

BOOL CPPgConnection::OnApply()
{
	TCHAR buffer[510];
	// Pawcio: BC added by [ionix] - MSS //Pawcio: MSS
	if(m_hWnd)
	{
		if (GetDlgItem(IDC_MSS)->GetWindowTextLength()){
			GetDlgItem(IDC_MSS)->GetWindowText(buffer,20);
			thePrefs.SetMSS( ((_tstoi(buffer)>=1300)&& _tstoi(buffer)<=1460) ? _tstoi(buffer) : 1300 );
		}

		// END added by [ionix] - MSS
	}
	int lastmaxgu = thePrefs.maxGraphUploadRate;
	int lastmaxgd = thePrefs.maxGraphDownloadRate;
	bool bRestartApp = false;

	if(GetDlgItem(IDC_DOWNLOAD_CAP)->GetWindowTextLength())
	{ 
		GetDlgItem(IDC_DOWNLOAD_CAP)->GetWindowText(buffer,20);
		thePrefs.SetMaxGraphDownloadRate(_tstoi(buffer));
	}
	if(GetDlgItem(IDC_UPLOAD_CAP)->GetWindowTextLength())
	{
		GetDlgItem(IDC_UPLOAD_CAP)->GetWindowText(buffer,20);
		thePrefs.SetMaxGraphUploadRate(_tstoi(buffer));
	}

	//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
	// Upload rate
	if (IsDlgButtonChecked(IDC_ULIMIT_LBL)==FALSE) thePrefs.SetMaxUpload(UNLIMITED);
	else if(GetDlgItem(IDC_MAXUP)->GetWindowTextLength())
	{
		GetDlgItem(IDC_MAXUP)->GetWindowText(buffer,20);
		double upload = _tstof(buffer);
		if (upload == 0.0f)
			thePrefs.SetMaxUpload(UNLIMITED);
		else
		thePrefs.SetMaxUpload(upload < 1.0f ? 1.0f : (float)upload);
	}
	if( thePrefs.GetMaxGraphUploadRate() < thePrefs.GetMaxUpload() && thePrefs.GetMaxUpload()!=UNLIMITED  )
		thePrefs.SetMaxUpload(thePrefs.GetMaxGraphUploadRate()*.8);
	// Download rate
	if (IsDlgButtonChecked(IDC_DLIMIT_LBL)==FALSE) thePrefs.SetMaxDownload(UNLIMITED);
	else if(GetDlgItem(IDC_MAXDOWN)->GetWindowTextLength())
	{
		GetDlgItem(IDC_MAXDOWN)->GetWindowText(buffer,20);
		double download = _tstof(buffer);
		if (download == 0.0f)
			thePrefs.SetMaxDownload(UNLIMITED);
		else
		thePrefs.SetMaxDownload(download < 1.0f ? 1.0f : (float)download);
	}
	//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-

	if( thePrefs.GetMaxGraphDownloadRate() < thePrefs.GetMaxDownload() && thePrefs.GetMaxDownload()!=UNLIMITED )
		thePrefs.SetMaxDownload(thePrefs.GetMaxGraphDownloadRate()*.8);

	if(GetDlgItem(IDC_PORT)->GetWindowTextLength())
	{
		GetDlgItem(IDC_PORT)->GetWindowText(buffer,20);
		uint16 nNewPort = (_tstoi(buffer)) ? _tstoi(buffer) : 4662;
		if (nNewPort != thePrefs.port){
			thePrefs.port = nNewPort;
			if (theApp.IsPortchangeAllowed())
				theApp.listensocket->Rebind();
			else
				bRestartApp = true;
			// WebCache: jp webcachesettings
			// yonatan WC-TODO: check out Rebind()
			// jp webcachesettings
			// this part crashes if Webcachesettings has not been active page at least once see PreferencesDlg.cpp (103)
			if	(((!thePrefs.UsesCachedTCPPort())	// not a good port for webcace
			&& thePrefs.IsWebCacheDownloadEnabled()		// webcache enabled
			&& theApp.emuledlg->preferenceswnd->m_wndWebcachesettings.IsDlgButtonChecked(IDC_Activatewebcachedownloads))  //if webcache was disabled but the change was not saved yet, no need for the message because it will be saved now
			|| (!thePrefs.UsesCachedTCPPort()		// not a good port for webcache
				&& theApp.emuledlg->preferenceswnd->m_wndWebcachesettings.IsDlgButtonChecked(IDC_Activatewebcachedownloads))) //webcache enabled but not yet saved to thePrefs. would be saved now but shouldn't
			{
				AfxMessageBox(GetResString(IDS_WrongPortforWebcache),MB_OK | MB_ICONINFORMATION,0);
				thePrefs.webcacheEnabled=false;			// disable webcache
			}
			
			theApp.emuledlg->preferenceswnd->m_wndWebcachesettings.LoadSettings();
			// <--- WebCache: jp end
		}
	}
	
	if(GetDlgItem(IDC_MAXSOURCEPERFILE)->GetWindowTextLength())
	{
		GetDlgItem(IDC_MAXSOURCEPERFILE)->GetWindowText(buffer,20);
		thePrefs.maxsourceperfile = (_tstoi(buffer)) ? _tstoi(buffer) : 1;
	}

	if(GetDlgItem(IDC_UDPPORT)->GetWindowTextLength())
	{
		GetDlgItem(IDC_UDPPORT)->GetWindowText(buffer,20);
		uint16 nNewPort = (_tstoi(buffer) && !IsDlgButtonChecked(IDC_UDPDISABLE) ) ? _tstoi(buffer) : 0;
		if (nNewPort != thePrefs.udpport){
			thePrefs.udpport = nNewPort;
			if (theApp.IsPortchangeAllowed())
				theApp.clientudp->Rebind();
			else 
				bRestartApp = true;
		}
	}

	if(IsDlgButtonChecked(IDC_SHOWOVERHEAD)){
		if (!thePrefs.m_bshowoverhead){
			// reset overhead data counters before starting to meassure!
			theStats.ResetDownDatarateOverhead();
			theStats.ResetUpDatarateOverhead();
		}
		thePrefs.m_bshowoverhead = true;
	}
	else{
		if (thePrefs.m_bshowoverhead){
			// free memory used by overhead computations
			theStats.ResetDownDatarateOverhead();
			theStats.ResetUpDatarateOverhead();
		}
		thePrefs.m_bshowoverhead = false;
	}

	if(IsDlgButtonChecked(IDC_NETWORK_KADEMLIA))
		thePrefs.SetNetworkKademlia(true);
	else
		thePrefs.SetNetworkKademlia(false);

	if(IsDlgButtonChecked(IDC_NETWORK_ED2K))
		thePrefs.SetNetworkED2K(true);
	else
		thePrefs.SetNetworkED2K(false);

	//	if(IsDlgButtonChecked(IDC_UDPDISABLE)) thePrefs.udpport=0;
	GetDlgItem(IDC_UDPPORT)->EnableWindow(!IsDlgButtonChecked(IDC_UDPDISABLE));

	thePrefs.autoconnect = (uint8)IsDlgButtonChecked(IDC_AUTOCONNECT);
	thePrefs.reconnect = (uint8)IsDlgButtonChecked(IDC_RECONN);
		
	if(lastmaxgu != thePrefs.maxGraphUploadRate) 
		theApp.emuledlg->statisticswnd->SetARange(false,thePrefs.maxGraphUploadRate);
	if(lastmaxgd!=thePrefs.maxGraphDownloadRate)
		theApp.emuledlg->statisticswnd->SetARange(true,thePrefs.maxGraphDownloadRate);

	uint16 tempcon = thePrefs.maxconnections;
	if(GetDlgItem(IDC_MAXCON)->GetWindowTextLength())
	{
		GetDlgItem(IDC_MAXCON)->GetWindowText(buffer,20);
		tempcon = (_tstoi(buffer)) ? _tstoi(buffer) : CPreferences::GetRecommendedMaxConnections();
	}

	if(tempcon > (unsigned)::GetMaxWindowsTCPConnections())
	{
		CString strMessage;
		strMessage.Format(GetResString(IDS_PW_WARNING), GetResString(IDS_PW_MAXC), ::GetMaxWindowsTCPConnections());
		int iResult = AfxMessageBox(strMessage, MB_ICONWARNING | MB_YESNO);
		if(iResult != IDYES)
		{
			//TODO: set focus to max connection?
			strMessage.Format(_T("%d"), thePrefs.maxconnections);
			GetDlgItem(IDC_MAXCON)->SetWindowText(strMessage);
			tempcon = ::GetMaxWindowsTCPConnections();
		}
	}
	thePrefs.maxconnections = tempcon;
	theApp.scheduler->SaveOriginals();

	//if (thePrefs.maxGraphDownloadRate<thePrefs.maxdownload) thePrefs.maxdownload=UNLIMITED;
	//if (thePrefs.maxGraphUploadRate<thePrefs.maxupload) thePrefs.maxupload=UNLIMITED;

	// [ionix] [MoNKi: -Random Ports-]
	if((bool)IsDlgButtonChecked(IDC_RANDOMPORTS) != thePrefs.GetUseRandomPorts()){
		bRestartApp = true;
		//MORPH START - Added by [ionix], [MoNKi: -Improved ICS-Firewall support-]
		theApp.m_pFirewallOpener->ClearMappingsAtEnd();
		//MORPH END   - Added by [ionix], [MoNKi: -Improved ICS-Firewall support-]
	}

	thePrefs.SetUseRandomPorts((BOOL)IsDlgButtonChecked(IDC_RANDOMPORTS));

	unsigned long rndValue1, rndValue2;
	CString rndText;
	m_minRndPort.GetWindowText(rndText);
	rndValue1 = _ttoi(rndText);
	m_maxRndPort.GetWindowText(rndText);
	rndValue2 = _ttoi(rndText);

	if (rndValue1 > 0xFFFF) rndValue1 = 0xFFFF;
	if (rndValue1 < 1) rndValue1 = 1;
	if (rndValue2 > 0xFFFF) rndValue2 = 0xFFFF;
	if (rndValue2 < 1) rndValue2 = 1;
	if (rndValue1 > rndValue2){
		int tmp = rndValue2;
		rndValue2 = rndValue1;
		rndValue1 = tmp;
	}

	if(rndValue1 != thePrefs.GetMinRandomPort() || rndValue2 != thePrefs.GetMaxRandomPort()){
		bRestartApp = true;
		thePrefs.SetMinRandomPort(rndValue1);
		thePrefs.SetMaxRandomPort(rndValue2);
	}
	// [ionix] [MoNKi: -Random Ports-]

	SetModified(FALSE);
	LoadSettings();

	theApp.emuledlg->ShowConnectionState();

//	thePrefs.Save();
//	theApp.emuledlg->preferenceswnd->m_wndTweaks.LoadSettings();

	if (bRestartApp)
		AfxMessageBox(GetResString(IDS_NOPORTCHANGEPOSSIBLE));

	OnEnChangePorts(2);

	return CPropertyPage::OnApply();
}

void CPPgConnection::Localize(void)
{	
	if(m_hWnd)
	{
		SetWindowText(GetResString(IDS_PW_CONNECTION));
		
		GetDlgItem(IDC_CAPACITIES_FRM)->SetWindowText(GetResString(IDS_PW_CON_CAPFRM));
		GetDlgItem(IDC_DCAP_LBL)->SetWindowText(GetResString(IDS_PW_CON_DOWNLBL));
		GetDlgItem(IDC_UCAP_LBL)->SetWindowText(GetResString(IDS_PW_CON_UPLBL));
		
		GetDlgItem(IDC_LIMITS_FRM)->SetWindowText(GetResString(IDS_PW_CON_LIMITFRM));
		
		GetDlgItem(IDC_DLIMIT_LBL)->SetWindowText(GetResString(IDS_PW_DOWNL));
		GetDlgItem(IDC_ULIMIT_LBL)->SetWindowText(GetResString(IDS_PW_UPL));

		GetDlgItem(IDC_CONNECTION_NETWORK)->SetWindowText(GetResString(IDS_NETWORK));

		GetDlgItem(IDC_KBS1)->SetWindowText(GetResString(IDS_KBYTESEC));
		GetDlgItem(IDC_KBS2)->SetWindowText(GetResString(IDS_KBYTESEC));
		GetDlgItem(IDC_KBS3)->SetWindowText(GetResString(IDS_KBYTESEC));
		GetDlgItem(IDC_KBS4)->SetWindowText(GetResString(IDS_KBYTESEC));


		GetDlgItem(IDC_MAXCONN_FRM)->SetWindowText(GetResString(IDS_PW_CONLIMITS));
		GetDlgItem(IDC_MAXCONLABEL)->SetWindowText(GetResString(IDS_PW_MAXC));

		GetDlgItem(IDC_SHOWOVERHEAD)->SetWindowText(GetResString(IDS_SHOWOVERHEAD));
		
		GetDlgItem(IDC_CLIENTPORT_FRM)->SetWindowText(GetResString(IDS_PW_CLIENTPORT));
		GetDlgItem(IDC_MAXSRC_FRM)->SetWindowText(GetResString(IDS_PW_MAXSOURCES));

		GetDlgItem(IDC_AUTOCONNECT)->SetWindowText(GetResString(IDS_PW_AUTOCON));
		GetDlgItem(IDC_RECONN)->SetWindowText(GetResString(IDS_PW_RECON));
		GetDlgItem(IDC_MAXSRCHARD_LBL)->SetWindowText(GetResString(IDS_HARDLIMIT));
		GetDlgItem(IDC_WIZARD)->SetWindowText(GetResString(IDS_WIZARD));
		GetDlgItem(IDC_UDPDISABLE)->SetWindowText(GetResString(IDS_UDPDISABLED));

		GetDlgItem(IDC_OPENPORTS)->SetWindowText(GetResString(IDS_FO_PREFBUTTON));
		SetDlgItemText(IDC_STARTTEST, GetResString(IDS_STARTTEST) );

	// [ionix] [MoNKi: -Random Ports-]
		GetDlgItem(IDC_RANDOMPORTS)->SetWindowText(GetResString(IDS_RANDOMPORTS));
		GetDlgItem(IDC_LBL_MIN)->SetWindowText(GetResString(IDS_MINPORT));
		GetDlgItem(IDC_LBL_MAX)->SetWindowText(GetResString(IDS_MAXPORT));
	// [ionix] [MoNKi: -Random Ports-]

		GetDlgItem(IDC_MSS_FRM)->SetWindowText(GetResString(IDS_MSS_FRM)); // Pawcio: BC
	}
}

void CPPgConnection::OnBnClickedWizard()
{
	CConnectionWizardDlg conWizard;
	conWizard.DoModal();
}

//Pawcio: BC - removed
void CPPgConnection::OnLimiterChange() {
	
	GetDlgItem(IDC_MAXDOWN)->ShowWindow( IsDlgButtonChecked(IDC_DLIMIT_LBL)?SW_SHOW:SW_HIDE);
	GetDlgItem(IDC_KBS1)->ShowWindow( IsDlgButtonChecked(IDC_DLIMIT_LBL)?SW_SHOW:SW_HIDE);
	GetDlgItem(IDC_MAXUP)->ShowWindow( IsDlgButtonChecked(IDC_ULIMIT_LBL)?SW_SHOW:SW_HIDE );
	GetDlgItem(IDC_KBS4)->ShowWindow( IsDlgButtonChecked(IDC_ULIMIT_LBL)?SW_SHOW:SW_HIDE);

	SetModified(TRUE);	
}

void CPPgConnection::OnHelp()
{
	theApp.ShowHelp(eMule_FAQ_Preferences_Connection);
}

BOOL CPPgConnection::OnCommand(WPARAM wParam, LPARAM lParam)
{
	if (wParam == ID_HELP)
	{
		OnHelp();
		return TRUE;
	}
	return __super::OnCommand(wParam, lParam);
}

BOOL CPPgConnection::OnHelpInfo(HELPINFO* pHelpInfo)
{
	OnHelp();
	return TRUE;
}

void CPPgConnection::OnBnClickedOpenports()
{
	OnApply();
	theApp.m_pFirewallOpener->RemoveRule(EMULE_DEFAULTRULENAME_UDP);
	theApp.m_pFirewallOpener->RemoveRule(EMULE_DEFAULTRULENAME_TCP);
	bool bAlreadyExisted = false;
	if (theApp.m_pFirewallOpener->DoesRuleExist(thePrefs.GetPort(), NAT_PROTOCOL_TCP) || theApp.m_pFirewallOpener->DoesRuleExist(thePrefs.GetUDPPort(), NAT_PROTOCOL_UDP)){
		bAlreadyExisted = true;
	}
	bool bResult = theApp.m_pFirewallOpener->OpenPort(thePrefs.GetPort(), NAT_PROTOCOL_TCP, EMULE_DEFAULTRULENAME_TCP, false);
	if (thePrefs.GetUDPPort() != 0)
		bResult = bResult && theApp.m_pFirewallOpener->OpenPort(thePrefs.GetUDPPort(), NAT_PROTOCOL_UDP, EMULE_DEFAULTRULENAME_UDP, false);
	if (bResult){
		if (!bAlreadyExisted)
			AfxMessageBox(GetResString(IDS_FO_PREF_SUCCCEEDED), MB_ICONINFORMATION | MB_OK);
		else
			// TODO: actually we could offer the user to remove existing rules
			AfxMessageBox(GetResString(IDS_FO_PREF_EXISTED), MB_ICONINFORMATION | MB_OK);
	}
	else
		AfxMessageBox(GetResString(IDS_FO_PREF_FAILED), MB_ICONSTOP | MB_OK);
}

void CPPgConnection::OnStartPortTest() {

	CString buffer;

	GetDlgItem(IDC_PORT)->GetWindowText(buffer);
	uint16 tcp= _tstoi(buffer);

	GetDlgItem(IDC_UDPPORT)->GetWindowText(buffer);
	uint16 udp= _tstoi(buffer);

	TriggerPortTest(tcp,udp);
}
	// [ionix] [MoNKi: -Random Ports-]
void CPPgConnection::OnRandomPortsChange() {
	CString udpStr;
	unsigned int udp;

	GetDlgItem(IDC_UDPPORT)->GetWindowText(udpStr);
	udp = _ttoi(udpStr);

	GetDlgItem(IDC_UDPPORT)->EnableWindow(!IsDlgButtonChecked(IDC_RANDOMPORTS) && udp>0);
	GetDlgItem(IDC_PORT)->EnableWindow(!IsDlgButtonChecked(IDC_RANDOMPORTS));
	m_minRndPort.EnableWindow(IsDlgButtonChecked(IDC_RANDOMPORTS));
	m_maxRndPort.EnableWindow(IsDlgButtonChecked(IDC_RANDOMPORTS));
	m_minRndPortSpin.EnableWindow(IsDlgButtonChecked(IDC_RANDOMPORTS));
	m_maxRndPortSpin.EnableWindow(IsDlgButtonChecked(IDC_RANDOMPORTS));

	SetModified(TRUE);	
}
	// [ionix] [MoNKi: -Random Ports-]
